SystemOrganization addCategory: #TpObjetos!

Object subclass: #Alumnos
	instanceVariableNames: 'atencion motivacion animo temasAprendidos calificacion'
	classVariableNames: 'Estados'
	poolDictionaries: ''
	category: 'TpObjetos'!

Alumnos class
	instanceVariableNames: 'atencion motivacion animo temasAprendidos calificacion'!

Alumnos class
	instanceVariableNames: 'atencion motivacion animo temasAprendidos calificacion'!

!Alumnos class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 05:29'!
iniciarEstados
Estados := OrderedCollection new.
Estados add: 'me quiero ir'.
Estados add: 'mas o menos'.
Estados add: 'todo bien'.
Estados add: 'con ganas de ser ayudante'.! !

!Alumnos class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 05:29'!
mostrarEstados
^Estados.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 05:36'!
animar
(animo = nil) 	ifTrue: [self animo: (Estados at: 1)]
				ifFalse: [(animo = (Estados at: 1)) ifTrue: [self animo: (Estados at: 2)]
				ifFalse: [(animo =(Estados at:2)) ifTrue: [self animo: (Estados at: 3)]
				ifFalse: [(animo = (Estados at:3)) ifTrue: [self animo: (Estados at: 4)]]]].! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
animo
^animo.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/20/2012 03:18'!
animo: unEstado
animo := unEstado.! !

!Alumnos methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 04:51'!
aprender: unTema
temasAprendidos add: unTema.! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
atencion
^atencion.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/20/2012 03:14'!
atencion: unNumero
atencion := unNumero.! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:00'!
calificacion
^calificacion.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 02:55'!
calificacion: unNumero
calificacion := unNumero.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 05:39'!
desanimar
(animo = (Estados at: 4)) ifTrue: [self animo: (Estados at: 3)]
				ifFalse: [(animo =(Estados at:3)) ifTrue: [self animo: (Estados at: 2)]
				ifFalse: [(animo = (Estados at:2)) ifTrue: [self animo: (Estados at: 1)]]].! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
desmotivar
motivacion := false.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
invertirMotivacion
(motivacion) ifTrue: [self desmotivar] ifFalse:[self motivar].! !

!Alumnos methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
motivacion
^motivacion.! !

!Alumnos methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
motivar
motivacion := true.! !

!Alumnos methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 03:44'!
new
^super new initialize! !

Object subclass: #Docente
	instanceVariableNames: 'curso temas temasVistos temasVistosMasDeDosVeces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 04:54'!
analogia
curso do: [:unAlumno | 
	((unAlumno atencion) > 30) 
		ifTrue:
		[unAlumno atencion: ((unAlumno atencion) +10).
		unAlumno motivar]
		
		ifFalse: [unAlumno desanimar]].! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:20'!
comenzarCurso
curso := Set new.
temas := Bag new.
temasVistos := Bag new.
temasVistosMasDeDosVeces := Bag new.! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:57'!
curso
^curso.! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 04:19'!
darTema: unTema
curso do: [:unAlumno| unAlumno aprender: unTema].
temasVistos add: unTema.
((temasVistos occurrencesOf: unTema) >0) ifTrue: [temasVistosMasDeDosVeces add: unTema].

! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:53'!
inscribir: unAlumno
curso add: unAlumno.! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 06:01'!
payasada
curso do: [:unAlumno |
	unAlumno atencion: ((unAlumno atencion) *2).
	unAlumno invertirMotivacion.
	((unAlumno animo) = 'con ganas de ser ayudante') ifTrue: [unAlumno animo: 'me quiero ir']
	ifFalse: [unAlumno animar]].
! !

!Docente methodsFor: 'Do' stamp: 'LeoComparin 9/23/2012 05:55'!
receso: unTiempo
curso do: [:unAlumno | 
			unAlumno atencion:  ((unAlumno atencion) + unTiempo).
			(((unAlumno animo) = 'me quiero ir' or: (unAlumno animo) = 'mas o menos') and: ((unAlumno atencion) < 50)) 
			ifTrue: [unAlumno atencion: ((unAlumno atencion) *2)]
			ifFalse: [unAlumno animar]].! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 04:10'!
temas
^temas.! !

Object subclass: #Temas
	instanceVariableNames: 'complejidad interes estado imprescindible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
complejidad
^complejidad.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:19'!
complejidad: algo
complejidad := algo.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:28'!
esImprescindible
imprescindible := true.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
estado
^estado.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:20'!
estado: algo
estado := algo.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
imprescindible
^imprescindible.! !

!Temas methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:22'!
interes
^interes.! !

!Temas methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 03:19'!
interes: unNumero
interes := unNumero.! !
